#ifndef AUDIOLIB__DSL_H
#define AUDIOLIB__DSL_H

#define MONO_8BIT   0
#define STEREO      1
#define SIXTEEN_BIT 2

enum DSL_ERRORS
   {
   DSL_Warning = -2,
   DSL_Amiga_Error = -1,
   DSL_Ok = 0,
   DSL_MixerAlreadyActive = -3,
   DSL_MixerInitFailure = -4
   };

char *DSL_Amiga_ErrorString( int Amiga_ErrorNumber );

int DSL_Init( void );
void DSL_Shutdown( void );

int DSL_BeginBufferedPlayback( char *BufferStart,
      int BufferSize, int NumDivisions, unsigned SampleRate,
      int MixMode, void ( *CallBackFunc )( void ) );


void DSL_StopPlayback( void );

unsigned DSL_GetPlaybackRate( void );


      


#endif
